﻿using System.Text.Json.Serialization;

namespace PrivaPub.ClientModels.User.Avatar
{
	[JsonSerializable(typeof(ViewAvatar))]
	public class ViewAvatar
	{
		public string Url { get; set; }//url
		public string Name { get; set; }//name
		public string UserName { get; set; }//preferredUsername
		public string Biography { get; set; }//summary
		public Dictionary<string, string> Fields { get; set; } = new();

		public string PictureURL { get; set; }//icon
		public string ThumbnailURL { get; set; }//image
		public Dictionary<string, string> SharedPersonalContacts { get; set; } = new();

		public ViewAvatarState AccountState { get; set; } = ViewAvatarState.Normal;
		public ViewAvatarServer ServerType { get; set; } = ViewAvatarServer.Unknown;

		public ViewAvatarSettings Settings { get; set; } = new();

		public DateTime UpdatedAt { get; set; }
		public DateTime CreatedAt { get; set; }
	}
}
