﻿using System.Text.Json.Serialization;

namespace PrivaPub.Models.ActivityPub
{
	[JsonSerializable(typeof(ActivityPubCollection))]
	public class ActivityPubCollection : ActivityPubObject
	{
		[JsonPropertyName("type")]
		public new ObjectType Type => ObjectType.Collection;

		[JsonPropertyName("current")]
		public string RecentlyUpdatedItem { get; set; }
		[JsonPropertyName("first")]
		public string FirstItem { get; set; }
		[JsonPropertyName("last")]
		public string LastItem { get; set; }

		[JsonPropertyName("items")]
		public List<ActivityPubLink> Items { get; set; }

		[JsonPropertyName("totalItems")]
		public int TotalItems => Items.Count;
	}
}
