﻿using System.Text.Json.Serialization;

namespace PrivaPub.Models.ActivityPub
{
	[JsonSerializable(typeof(ActivityPubOrderedCollectionPage))]
	public class ActivityPubOrderedCollectionPage : ActivityPubCollection
	{
		[JsonPropertyName("type")]
		public new ObjectType Type => ObjectType.OrderedCollectionPage;

		[JsonPropertyName("partOf")]
		public string BaseCollectionLink { get; set; }
		[JsonPropertyName("next")]
		public string NextCollectionLink { get; set; }
		[JsonPropertyName("prev")]
		public string PreviousCollectionLink { get; set; }

		[JsonPropertyName("startIndex")]
		public uint? StartIndex { get; set; }

		[JsonPropertyName("orderedItems")]
		public List<ActivityPubLink> OrderedItems { get; set; }

		[JsonPropertyName("totalItems")]
		public new int TotalItems => OrderedItems?.Count ?? default;
	}
}
