﻿using MongoDB.Entities;

using PrivaPub.Models.Email;
using PrivaPub.StaticServices;

namespace PrivaPub.Models
{
	public class AppConfiguration : Entity
	{
		public bool RequiresFirstTimeSetup { get; set; } = true;
		public string Version { get; set; }
		public int MaxAllowedUploadFiles { get; set; }
		public int MaxAllowedFileSize { get; set; }
		public string ValidDiscussionFilesTypes { get; set; }
		public List<string> SupportedLanguages { get; set; } = new();
		public string BackendBaseAddress { get; set; }
		public EmailConfiguration EmailConfiguration { get; set; }
		public HashingOptions HashingOptions { get; set; }
		public DateTime LastUpdateDate { get; set; } = DateTime.UtcNow;
	}
}