﻿#pragma warning disable 8625

using PrivaPub.ClientModels;
using PrivaPub.ClientModels.User;

namespace PrivaPub.Services
{
	public interface IRootUsersService
	{
		Task<WebResult> LoginAsync(LoginForm loginForm, string invitationCode = default, bool isPasswordRequired = false);

		Task<WebResult> SignUpAsync(LoginForm signUpForm, string invitationCode = default, bool isPasswordRequired = false);

		Task<WebResult> BanUserAsync(UsersIds usersIds);

		Task<WebResult> UnbanUserAsync(UsersIds usersIds);

		Task<WebResult> RemoveUserAsync(UsersIds usersIds);

		Task<WebResult> UpdateUserAsync(UserForm userEmailForm, string userId);

		Task<WebResult> UpdateUserPasswordAsync(UserPasswordForm userPasswordForm, string userId);

		Task<WebResult> GetUserSettingsAsync(string userId, LoginForm loginForm = default);

		Task<WebResult> UpdateUserSettingsAsync(ViewAvatarServer userSettings, string userId);

		Task<WebResult> SetupAndSendRecoveryEmail(PasswordRecoveryForm passwordRecoveryForm, string host);

		Task<WebResult> IsValidRecoveryCode(string recoveryCode);

		Task<WebResult> ChangePassword(NewPasswordForm newPasswordForm);
	}
}